diff --git a/Demo/Makefile.am b/Demo/Makefile.am
new file mode 100644
--- /dev/null
+++ b/Demo/Makefile.am
@@ -0,0 +1,111 @@
+AM_CPPFLAGS = -I$(top_srcdir)/Include $(CHOLMOD_CFLAGS) $(SUITESPARSECONFIG_CFLAGS)
+LDADD = $(top_builddir)/Source/libspqr.la
+
+EXTRA_DIST = \
+	README.txt \
+	qrdemo_out.txt \
+	qrdemoc_out.txt
+
+check_PROGRAMS = \
+	qrsimple \
+	qrsimplec \
+	qrdemo \
+	qrdemoc
+
+qrsimple_SOURCES = qrsimple.cpp
+qrsimplec_SOURCES = qrsimplec.c
+qrsimplec_CFLAGS = $(AM_CFLAGS) -ansi
+qrdemo_SOURCES = qrdemo.cpp
+qrdemoc_SOURCES = qrdemoc.c
+qrdemoc_CFLAGS = $(AM_CFLAGS) -ansi
+
+MATRICES = \
+	$(top_srcdir)/Matrix/GD01_b.mtx \
+	$(top_srcdir)/Matrix/GD06_theory.mtx \
+	$(top_srcdir)/Matrix/GD98_a.mtx \
+	$(top_srcdir)/Matrix/LFAT5.mtx \
+	$(top_srcdir)/Matrix/Ragusa16.mtx \
+	$(top_srcdir)/Matrix/Tina_AskCal.mtx \
+	$(top_srcdir)/Matrix/Tina_AskCal_perm.mtx \
+	$(top_srcdir)/Matrix/a0.mtx \
+	$(top_srcdir)/Matrix/a04.mtx \
+	$(top_srcdir)/Matrix/a1.mtx \
+	$(top_srcdir)/Matrix/a2.mtx \
+	$(top_srcdir)/Matrix/a4.mtx \
+	$(top_srcdir)/Matrix/ash219.mtx \
+	$(top_srcdir)/Matrix/b1_ss.mtx \
+	$(top_srcdir)/Matrix/bcspwr01.mtx \
+	$(top_srcdir)/Matrix/bfwa62.mtx \
+	$(top_srcdir)/Matrix/c2.mtx \
+	$(top_srcdir)/Matrix/c32.mtx \
+	$(top_srcdir)/Matrix/lfat5b.mtx \
+	$(top_srcdir)/Matrix/lp_share1b.mtx \
+	$(top_srcdir)/Matrix/lpi_galenet.mtx \
+	$(top_srcdir)/Matrix/lpi_itest6.mtx \
+	$(top_srcdir)/Matrix/r2.mtx \
+	$(top_srcdir)/Matrix/s32.mtx \
+	$(top_srcdir)/Matrix/west0067.mtx \
+	$(top_srcdir)/Matrix/young1c.mtx \
+	$(top_srcdir)/Matrix/lp_e226_transposed.mtx
+
+check-local: $(check_PROGRAMS) $(MATRICES)
+	-./qrsimple < $(top_srcdir)/Matrix/ash219.mtx
+	-./qrsimplec < $(top_srcdir)/Matrix/ash219.mtx
+	-./qrsimple < $(top_srcdir)/Matrix/west0067.mtx
+	-./qrsimplec < $(top_srcdir)/Matrix/west0067.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/a2.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/r2.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/a04.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/a2.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/west0067.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/c2.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/a0.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/lfat5b.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/bfwa62.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/LFAT5.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/b1_ss.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/bcspwr01.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/lpi_galenet.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/lpi_itest6.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/ash219.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/a4.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/s32.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/c32.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/lp_share1b.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/a1.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/GD06_theory.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/GD01_b.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/Tina_AskCal_perm.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/Tina_AskCal.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/GD98_a.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/Ragusa16.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/young1c.mtx
+	-./qrdemo < $(top_srcdir)/Matrix/lp_e226_transposed.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/a2.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/r2.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/a04.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/a2.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/west0067.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/c2.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/a0.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/lfat5b.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/bfwa62.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/LFAT5.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/b1_ss.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/bcspwr01.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/lpi_galenet.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/lpi_itest6.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/ash219.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/a4.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/s32.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/c32.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/lp_share1b.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/a1.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/GD06_theory.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/GD01_b.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/Tina_AskCal_perm.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/Tina_AskCal.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/GD98_a.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/Ragusa16.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/young1c.mtx
+	-./qrdemoc < $(top_srcdir)/Matrix/lp_e226_transposed.mtx
diff --git a/Doc/Makefile.am b/Doc/Makefile.am
new file mode 100644
--- /dev/null
+++ b/Doc/Makefile.am
@@ -0,0 +1,28 @@
+EXTRA_DIST = \
+	ChangeLog \
+	README.txt \
+	gpl.txt
+
+dist_noinst_DATA = \
+	spqr_user_guide.tex \
+	spqr_user_guide.bib
+
+dist_pdf_DATA = \
+	spqr_user_guide.pdf \
+	algo_spqr.pdf \
+	spqr.pdf
+
+TEX = TEXINPUTS="$(srcdir):" pdflatex -interaction nonstopmode -file-line-error
+BIB = BIBINPUTS="$(srcdir):" bibtex
+%.pdf: %.tex %.bbl
+	$(TEX) $*
+	while grep -q "Rerun to get cross-references right" $*.log; do \
+		$(TEX) $*; \
+	done
+%.bbl: %.aux %.bib
+	$(BIB) $*
+%.aux: %.tex
+	$(TEX) $*
+
+CLEANFILES = *.aux *.bbl *.blg *.log *.toc
+MAINTAINERCLEANFILES = $(dist_pdf_DATA)
diff --git a/Include/Makefile.am b/Include/Makefile.am
new file mode 100644
--- /dev/null
+++ b/Include/Makefile.am
@@ -0,0 +1,5 @@
+pkginclude_HEADERS = \
+	SuiteSparseQR.hpp \
+	SuiteSparseQR_C.h \
+	SuiteSparseQR_definitions.h \
+	spqr.hpp
diff --git a/Makefile.am b/Makefile.am
new file mode 100644
--- /dev/null
+++ b/Makefile.am
@@ -0,0 +1,5 @@
+SUBDIRS = Include Source Matrix Demo Doc
+EXTRA_DIST = README.txt
+
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = spqr.pc
diff --git a/Matrix/Makefile.am b/Matrix/Makefile.am
new file mode 100644
--- /dev/null
+++ b/Matrix/Makefile.am
@@ -0,0 +1,36 @@
+EXTRA_DIST = \
+	README.txt
+
+dist_noinst_DATA = \
+	GD01_b.mtx \
+	GD06_theory.mtx \
+	GD98_a.mtx \
+	LFAT5.mtx \
+	Ragusa16.mtx \
+	Tina_AskCal.mtx \
+	Tina_AskCal_perm.mtx \
+	a0.mtx \
+	a04.mtx \
+	a1.mtx \
+	a2.mtx \
+	a4.mtx \
+	arrow.mtx \
+	ash219.mtx \
+	b1_ss.mtx \
+	bcspwr01.mtx \
+	bfwa62.mtx \
+	c2.mtx \
+	c32.mtx \
+	lfat5b.mtx \
+	lp_share1b.mtx \
+	lpi_galenet.mtx \
+	lpi_itest6.mtx \
+	pwr01b.mtx \
+	r2.mtx \
+	s32.mtx \
+	west0067.mtx \
+	young1c.mtx \
+	Franz6_id1959_aug.mtx \
+	Groebner_id2003_aug.mtx \
+	lp_e226.mtx \
+	lp_e226_transposed.mtx
diff --git a/Source/Makefile.am b/Source/Makefile.am
new file mode 100644
--- /dev/null
+++ b/Source/Makefile.am
@@ -0,0 +1,54 @@
+AM_CPPFLAGS = -I$(top_srcdir)/Include $(TBB_CFLAGS) $(CHOLMOD_CFLAGS) $(SUITESPARSECONFIG_CFLAGS)
+if !EXPERT
+AM_CPPFLAGS += -DNEXPERT
+endif
+if TBB
+AM_CPPFLAGS += -DHAVE_TBB
+endif
+
+lib_LTLIBRARIES = libspqr.la
+
+libspqr_la_SOURCES = \
+	SuiteSparseQR.cpp \
+	SuiteSparseQR_C.cpp \
+	SuiteSparseQR_expert.cpp \
+	SuiteSparseQR_qmult.cpp \
+	spqr_1colamd.cpp \
+	spqr_1factor.cpp \
+	spqr_1fixed.cpp \
+	spqr_analyze.cpp \
+	spqr_append.cpp \
+	spqr_assemble.cpp \
+	spqr_cpack.cpp \
+	spqr_csize.cpp \
+	spqr_cumsum.cpp \
+	spqr_debug.cpp \
+	spqr_factorize.cpp \
+	spqr_fcsize.cpp \
+	spqr_freefac.cpp \
+	spqr_freenum.cpp \
+	spqr_freesym.cpp \
+	spqr_front.cpp \
+	spqr_fsize.cpp \
+	spqr_happly.cpp \
+	spqr_happly_work.cpp \
+	spqr_hpinv.cpp \
+	spqr_kernel.cpp \
+	spqr_larftb.cpp \
+	spqr_maxcolnorm.cpp \
+	spqr_panel.cpp \
+	spqr_parallel.cpp \
+	spqr_rconvert.cpp \
+	spqr_rcount.cpp \
+	spqr_rhpack.cpp \
+	spqr_rmap.cpp \
+	spqr_rsolve.cpp \
+	spqr_shift.cpp \
+	spqr_stranspose1.cpp \
+	spqr_stranspose2.cpp \
+	spqr_tol.cpp \
+	spqr_trapezoidal.cpp \
+	spqr_type.cpp
+
+libspqr_la_LIBADD = $(TBB_LIBS) $(CHOLMOD_LIBS) $(SUITESPARSECONFIG_LIBS) $(LAPACK_LIBS) $(BLAS_LIBS) -lm
+libspqr_la_LDFLAGS = -no-undefined -release $(PACKAGE_VERSION)
diff --git a/ax_blas.m4 b/ax_blas.m4
new file mode 100644
--- /dev/null
+++ b/ax_blas.m4
@@ -0,0 +1,238 @@
+# ===========================================================================
+#          http://www.gnu.org/software/autoconf-archive/ax_blas.html
+# ===========================================================================
+#
+# SYNOPSIS
+#
+#   AX_BLAS([ACTION-IF-FOUND[, ACTION-IF-NOT-FOUND]])
+#
+# DESCRIPTION
+#
+#   This macro looks for a library that implements the BLAS linear-algebra
+#   interface (see http://www.netlib.org/blas/). On success, it sets the
+#   BLAS_LIBS output variable to hold the requisite library linkages.
+#
+#   To link with BLAS, you should link with:
+#
+#     $BLAS_LIBS $LIBS $FLIBS
+#
+#   in that order. FLIBS is the output variable of the
+#   AC_F77_LIBRARY_LDFLAGS macro (called if necessary by AX_BLAS), and is
+#   sometimes necessary in order to link with F77 libraries. Users will also
+#   need to use AC_F77_DUMMY_MAIN (see the autoconf manual), for the same
+#   reason.
+#
+#   Many libraries are searched for, from ATLAS to CXML to ESSL. The user
+#   may also use --with-blas=<lib> in order to use some specific BLAS
+#   library <lib>. In order to link successfully, however, be aware that you
+#   will probably need to use the same Fortran compiler (which can be set
+#   via the F77 env. var.) as was used to compile the BLAS library.
+#
+#   ACTION-IF-FOUND is a list of shell commands to run if a BLAS library is
+#   found, and ACTION-IF-NOT-FOUND is a list of commands to run it if it is
+#   not found. If ACTION-IF-FOUND is not specified, the default action will
+#   define HAVE_BLAS.
+#
+# LICENSE
+#
+#   Copyright (c) 2008 Steven G. Johnson <stevenj@alum.mit.edu>
+#
+#   This program is free software: you can redistribute it and/or modify it
+#   under the terms of the GNU General Public License as published by the
+#   Free Software Foundation, either version 3 of the License, or (at your
+#   option) any later version.
+#
+#   This program is distributed in the hope that it will be useful, but
+#   WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+#   Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License along
+#   with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+#   As a special exception, the respective Autoconf Macro's copyright owner
+#   gives unlimited permission to copy, distribute and modify the configure
+#   scripts that are the output of Autoconf when processing the Macro. You
+#   need not follow the terms of the GNU General Public License when using
+#   or distributing such scripts, even though portions of the text of the
+#   Macro appear in them. The GNU General Public License (GPL) does govern
+#   all other use of the material that constitutes the Autoconf Macro.
+#
+#   This special exception to the GPL applies to versions of the Autoconf
+#   Macro released by the Autoconf Archive. When you make and distribute a
+#   modified version of the Autoconf Macro, you may extend this special
+#   exception to the GPL to apply to your modified version as well.
+
+#serial 14
+
+AU_ALIAS([ACX_BLAS], [AX_BLAS])
+AC_DEFUN([AX_BLAS], [
+AC_PREREQ(2.50)
+AC_REQUIRE([AC_F77_LIBRARY_LDFLAGS])
+AC_REQUIRE([AC_CANONICAL_HOST])
+ax_blas_ok=no
+
+AC_ARG_WITH(blas,
+	[AS_HELP_STRING([--with-blas=<lib>], [use BLAS library <lib>])])
+case $with_blas in
+	yes | "") ;;
+	no) ax_blas_ok=disable ;;
+	-* | */* | *.a | *.so | *.so.* | *.o) BLAS_LIBS="$with_blas" ;;
+	*) BLAS_LIBS="-l$with_blas" ;;
+esac
+
+# Get fortran linker names of BLAS functions to check for.
+AC_F77_FUNC(sgemm)
+AC_F77_FUNC(dgemm)
+
+ax_blas_save_LIBS="$LIBS"
+LIBS="$LIBS $FLIBS"
+
+# First, check BLAS_LIBS environment variable
+if test $ax_blas_ok = no; then
+if test "x$BLAS_LIBS" != x; then
+	save_LIBS="$LIBS"; LIBS="$BLAS_LIBS $LIBS"
+	AC_MSG_CHECKING([for $sgemm in $BLAS_LIBS])
+	AC_TRY_LINK_FUNC($sgemm, [ax_blas_ok=yes], [BLAS_LIBS=""])
+	AC_MSG_RESULT($ax_blas_ok)
+	LIBS="$save_LIBS"
+fi
+fi
+
+# BLAS linked to by default?  (happens on some supercomputers)
+if test $ax_blas_ok = no; then
+	save_LIBS="$LIBS"; LIBS="$LIBS"
+	AC_MSG_CHECKING([if $sgemm is being linked in already])
+	AC_TRY_LINK_FUNC($sgemm, [ax_blas_ok=yes])
+	AC_MSG_RESULT($ax_blas_ok)
+	LIBS="$save_LIBS"
+fi
+
+# BLAS in OpenBLAS library? (http://xianyi.github.com/OpenBLAS/)
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(openblas, $sgemm, [ax_blas_ok=yes
+			                BLAS_LIBS="-lopenblas"])
+fi
+
+# BLAS in ATLAS library? (http://math-atlas.sourceforge.net/)
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(atlas, ATL_xerbla,
+		[AC_CHECK_LIB(f77blas, $sgemm,
+		[AC_CHECK_LIB(cblas, cblas_dgemm,
+			[ax_blas_ok=yes
+			 BLAS_LIBS="-lcblas -lf77blas -latlas"],
+			[], [-lf77blas -latlas])],
+			[], [-latlas])])
+fi
+
+# BLAS in PhiPACK libraries? (requires generic BLAS lib, too)
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(blas, $sgemm,
+		[AC_CHECK_LIB(dgemm, $dgemm,
+		[AC_CHECK_LIB(sgemm, $sgemm,
+			[ax_blas_ok=yes; BLAS_LIBS="-lsgemm -ldgemm -lblas"],
+			[], [-lblas])],
+			[], [-lblas])])
+fi
+
+# BLAS in Intel MKL library?
+if test $ax_blas_ok = no; then
+	# MKL for gfortran
+	if test x"$ac_cv_fc_compiler_gnu" = xyes; then
+		# 64 bit
+		if test $host_cpu = x86_64; then
+			AC_CHECK_LIB(mkl_gf_lp64, $sgemm,
+			[ax_blas_ok=yes;BLAS_LIBS="-lmkl_gf_lp64 -lmkl_sequential -lmkl_core -lpthread"],,
+			[-lmkl_gf_lp64 -lmkl_sequential -lmkl_core -lpthread])
+		# 32 bit
+		elif test $host_cpu = i686; then
+			AC_CHECK_LIB(mkl_gf, $sgemm,
+				[ax_blas_ok=yes;BLAS_LIBS="-lmkl_gf -lmkl_sequential -lmkl_core -lpthread"],,
+				[-lmkl_gf -lmkl_sequential -lmkl_core -lpthread])
+		fi
+	# MKL for other compilers (Intel, PGI, ...?)
+	else
+		# 64-bit
+		if test $host_cpu = x86_64; then
+			AC_CHECK_LIB(mkl_intel_lp64, $sgemm,
+				[ax_blas_ok=yes;BLAS_LIBS="-lmkl_intel_lp64 -lmkl_sequential -lmkl_core -lpthread"],,
+				[-lmkl_intel_lp64 -lmkl_sequential -lmkl_core -lpthread])
+		# 32-bit
+		elif test $host_cpu = i686; then
+			AC_CHECK_LIB(mkl_intel, $sgemm,
+				[ax_blas_ok=yes;BLAS_LIBS="-lmkl_intel -lmkl_sequential -lmkl_core -lpthread"],,
+				[-lmkl_intel -lmkl_sequential -lmkl_core -lpthread])
+		fi
+	fi
+fi
+# Old versions of MKL
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(mkl, $sgemm, [ax_blas_ok=yes;BLAS_LIBS="-lmkl -lguide -lpthread"],,[-lguide -lpthread])
+fi
+
+# BLAS in Apple vecLib library?
+if test $ax_blas_ok = no; then
+	save_LIBS="$LIBS"; LIBS="-framework vecLib $LIBS"
+	AC_MSG_CHECKING([for $sgemm in -framework vecLib])
+	AC_TRY_LINK_FUNC($sgemm, [ax_blas_ok=yes;BLAS_LIBS="-framework vecLib"])
+	AC_MSG_RESULT($ax_blas_ok)
+	LIBS="$save_LIBS"
+fi
+
+# BLAS in Alpha CXML library?
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(cxml, $sgemm, [ax_blas_ok=yes;BLAS_LIBS="-lcxml"])
+fi
+
+# BLAS in Alpha DXML library? (now called CXML, see above)
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(dxml, $sgemm, [ax_blas_ok=yes;BLAS_LIBS="-ldxml"])
+fi
+
+# BLAS in Sun Performance library?
+if test $ax_blas_ok = no; then
+	if test "x$GCC" != xyes; then # only works with Sun CC
+		AC_CHECK_LIB(sunmath, acosp,
+			[AC_CHECK_LIB(sunperf, $sgemm,
+				[BLAS_LIBS="-xlic_lib=sunperf -lsunmath"
+                                 ax_blas_ok=yes],[],[-lsunmath])])
+	fi
+fi
+
+# BLAS in SCSL library?  (SGI/Cray Scientific Library)
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(scs, $sgemm, [ax_blas_ok=yes; BLAS_LIBS="-lscs"])
+fi
+
+# BLAS in SGIMATH library?
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(complib.sgimath, $sgemm,
+		     [ax_blas_ok=yes; BLAS_LIBS="-lcomplib.sgimath"])
+fi
+
+# BLAS in IBM ESSL library? (requires generic BLAS lib, too)
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(blas, $sgemm,
+		[AC_CHECK_LIB(essl, $sgemm,
+			[ax_blas_ok=yes; BLAS_LIBS="-lessl -lblas"],
+			[], [-lblas $FLIBS])])
+fi
+
+# Generic BLAS library?
+if test $ax_blas_ok = no; then
+	AC_CHECK_LIB(blas, $sgemm, [ax_blas_ok=yes; BLAS_LIBS="-lblas"])
+fi
+
+AC_SUBST(BLAS_LIBS)
+
+LIBS="$ax_blas_save_LIBS"
+
+# Finally, execute ACTION-IF-FOUND/ACTION-IF-NOT-FOUND:
+if test x"$ax_blas_ok" = xyes; then
+        ifelse([$1],,AC_DEFINE(HAVE_BLAS,1,[Define if you have a BLAS library.]),[$1])
+        :
+else
+        ax_blas_ok=no
+        $2
+fi
+])dnl AX_BLAS
diff --git a/ax_lapack.m4 b/ax_lapack.m4
new file mode 100644
--- /dev/null
+++ b/ax_lapack.m4
@@ -0,0 +1,131 @@
+# ===========================================================================
+#         http://www.gnu.org/software/autoconf-archive/ax_lapack.html
+# ===========================================================================
+#
+# SYNOPSIS
+#
+#   AX_LAPACK([ACTION-IF-FOUND[, ACTION-IF-NOT-FOUND]])
+#
+# DESCRIPTION
+#
+#   This macro looks for a library that implements the LAPACK linear-algebra
+#   interface (see http://www.netlib.org/lapack/). On success, it sets the
+#   LAPACK_LIBS output variable to hold the requisite library linkages.
+#
+#   To link with LAPACK, you should link with:
+#
+#     $LAPACK_LIBS $BLAS_LIBS $LIBS $FLIBS
+#
+#   in that order. BLAS_LIBS is the output variable of the AX_BLAS macro,
+#   called automatically. FLIBS is the output variable of the
+#   AC_F77_LIBRARY_LDFLAGS macro (called if necessary by AX_BLAS), and is
+#   sometimes necessary in order to link with F77 libraries. Users will also
+#   need to use AC_F77_DUMMY_MAIN (see the autoconf manual), for the same
+#   reason.
+#
+#   The user may also use --with-lapack=<lib> in order to use some specific
+#   LAPACK library <lib>. In order to link successfully, however, be aware
+#   that you will probably need to use the same Fortran compiler (which can
+#   be set via the F77 env. var.) as was used to compile the LAPACK and BLAS
+#   libraries.
+#
+#   ACTION-IF-FOUND is a list of shell commands to run if a LAPACK library
+#   is found, and ACTION-IF-NOT-FOUND is a list of commands to run it if it
+#   is not found. If ACTION-IF-FOUND is not specified, the default action
+#   will define HAVE_LAPACK.
+#
+# LICENSE
+#
+#   Copyright (c) 2009 Steven G. Johnson <stevenj@alum.mit.edu>
+#
+#   This program is free software: you can redistribute it and/or modify it
+#   under the terms of the GNU General Public License as published by the
+#   Free Software Foundation, either version 3 of the License, or (at your
+#   option) any later version.
+#
+#   This program is distributed in the hope that it will be useful, but
+#   WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+#   Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License along
+#   with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+#   As a special exception, the respective Autoconf Macro's copyright owner
+#   gives unlimited permission to copy, distribute and modify the configure
+#   scripts that are the output of Autoconf when processing the Macro. You
+#   need not follow the terms of the GNU General Public License when using
+#   or distributing such scripts, even though portions of the text of the
+#   Macro appear in them. The GNU General Public License (GPL) does govern
+#   all other use of the material that constitutes the Autoconf Macro.
+#
+#   This special exception to the GPL applies to versions of the Autoconf
+#   Macro released by the Autoconf Archive. When you make and distribute a
+#   modified version of the Autoconf Macro, you may extend this special
+#   exception to the GPL to apply to your modified version as well.
+
+#serial 7
+
+AU_ALIAS([ACX_LAPACK], [AX_LAPACK])
+AC_DEFUN([AX_LAPACK], [
+AC_REQUIRE([AX_BLAS])
+ax_lapack_ok=no
+
+AC_ARG_WITH(lapack,
+        [AS_HELP_STRING([--with-lapack=<lib>], [use LAPACK library <lib>])])
+case $with_lapack in
+        yes | "") ;;
+        no) ax_lapack_ok=disable ;;
+        -* | */* | *.a | *.so | *.so.* | *.o) LAPACK_LIBS="$with_lapack" ;;
+        *) LAPACK_LIBS="-l$with_lapack" ;;
+esac
+
+# Get fortran linker name of LAPACK function to check for.
+AC_F77_FUNC(cheev)
+
+# We cannot use LAPACK if BLAS is not found
+if test "x$ax_blas_ok" != xyes; then
+        ax_lapack_ok=noblas
+        LAPACK_LIBS=""
+fi
+
+# First, check LAPACK_LIBS environment variable
+if test "x$LAPACK_LIBS" != x; then
+        save_LIBS="$LIBS"; LIBS="$LAPACK_LIBS $BLAS_LIBS $LIBS $FLIBS"
+        AC_MSG_CHECKING([for $cheev in $LAPACK_LIBS])
+        AC_TRY_LINK_FUNC($cheev, [ax_lapack_ok=yes], [LAPACK_LIBS=""])
+        AC_MSG_RESULT($ax_lapack_ok)
+        LIBS="$save_LIBS"
+        if test $ax_lapack_ok = no; then
+                LAPACK_LIBS=""
+        fi
+fi
+
+# LAPACK linked to by default?  (is sometimes included in BLAS lib)
+if test $ax_lapack_ok = no; then
+        save_LIBS="$LIBS"; LIBS="$LIBS $BLAS_LIBS $FLIBS"
+        AC_CHECK_FUNC($cheev, [ax_lapack_ok=yes])
+        LIBS="$save_LIBS"
+fi
+
+# Generic LAPACK library?
+for lapack in lapack lapack_rs6k; do
+        if test $ax_lapack_ok = no; then
+                save_LIBS="$LIBS"; LIBS="$BLAS_LIBS $LIBS"
+                AC_CHECK_LIB($lapack, $cheev,
+                    [ax_lapack_ok=yes; LAPACK_LIBS="-l$lapack"], [], [$FLIBS])
+                LIBS="$save_LIBS"
+        fi
+done
+
+AC_SUBST(LAPACK_LIBS)
+
+# Finally, execute ACTION-IF-FOUND/ACTION-IF-NOT-FOUND:
+if test x"$ax_lapack_ok" = xyes; then
+        ifelse([$1],,AC_DEFINE(HAVE_LAPACK,1,[Define if you have LAPACK library.]),[$1])
+        :
+else
+        ax_lapack_ok=no
+        $2
+fi
+])dnl AX_LAPACK
diff --git a/configure.ac b/configure.ac
new file mode 100644
--- /dev/null
+++ b/configure.ac
@@ -0,0 +1,92 @@
+#                                               -*- Autoconf -*-
+# Process this file with autoconf to produce a configure script.
+
+AC_PREREQ([2.69])
+AC_INIT([SPQR],[2.0.2],[DrTimothyAldenDavis@gmail.com],[spqr],[http://www.suitesparse.com/])
+AC_CONFIG_SRCDIR([Source/spqr_kernel.cpp])
+AC_CONFIG_HEADERS([config.h])
+AM_INIT_AUTOMAKE([foreign])
+LT_INIT
+
+# Checks for programs.
+AC_PROG_INSTALL
+AC_PROG_F77
+AC_PROG_CC
+AC_PROG_CXX
+AC_LANG([C++])
+
+AC_MSG_CHECKING([whether to use expert routines])
+AC_ARG_ENABLE([expert],
+	[AS_HELP_STRING(
+		[--disable-expert],
+		[compile without the min 2-norm solution option])],
+	[expert=$enableval],
+	[expert="yes"])
+AC_MSG_RESULT([$expert])
+
+AC_MSG_CHECKING([whether to use tbb])
+AC_ARG_WITH([tbb],
+	[AS_HELP_STRING(
+		[--without-tbb],
+		[do not use Intel Threading Building Blocks for multithreading])],
+	[tbb=$withval],
+	[tbb="yes"])
+AC_MSG_RESULT([$tbb])
+
+LIBS_SAVED=$LIBS
+
+# Checks for libraries.
+AC_CHECK_LIB([m], [sqrt])
+
+sinclude([ax_blas.m4])
+AX_BLAS
+if test "x$ax_blas_ok" != "xyes"; then
+	AC_MSG_ERROR([cannot find blas])
+fi
+
+sinclude([ax_lapack.m4])
+AX_LAPACK
+if test "x$ax_lapack_ok" != "xyes"; then
+	AC_MSG_ERROR([cannot find lapack])
+fi
+
+PKG_PROG_PKG_CONFIG
+PKG_CHECK_MODULES([SUITESPARSECONFIG],[suitesparseconfig],
+	[],
+	[AC_MSG_ERROR([cannot find suitesparseconfig])])
+PKG_CHECK_MODULES([CHOLMOD],[cholmod],
+	[],
+	[AC_MSG_ERROR([cannot find cholmod])])
+
+# Checks for header files.
+AC_CHECK_HEADERS([float.h stdlib.h])
+
+if test "x$tbb" = "xyes"; then
+	AC_CHECK_HEADERS([tbb/task_scheduler_init.h tbb/task.h])
+fi
+
+# Checks for typedefs, structures, and compiler characteristics.
+AC_TYPE_SIZE_T
+
+# Checks for library functions.
+AC_CHECK_FUNCS([sqrt])
+
+LIBS=$LIBS_SAVED
+
+if test "x$tbb" = "xyes"; then
+	AC_SUBST([TBB_CFLAGS], [""])
+	AC_SUBST([TBB_LIBS], ["-ltbb"])
+fi
+
+AM_CONDITIONAL([EXPERT], [test "x$expert" = "xyes"])
+AM_CONDITIONAL([TBB], [test "x$tbb" = "xyes"])
+
+AC_CONFIG_FILES([
+	spqr.pc
+	Makefile
+	Demo/Makefile
+	Doc/Makefile
+	Include/Makefile
+	Matrix/Makefile
+	Source/Makefile])
+AC_OUTPUT
diff --git a/spqr.pc.in b/spqr.pc.in
new file mode 100644
--- /dev/null
+++ b/spqr.pc.in
@@ -0,0 +1,13 @@
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+libdir=@libdir@
+includedir=@includedir@
+
+Name: @PACKAGE_NAME@
+Description: Multifrontal sparse QR factorization
+Version: @PACKAGE_VERSION@
+URL: @PACKAGE_URL@
+Requires.private: cholmod suitesparseconfig
+Libs: -L${libdir} -lspqr
+Libs.private: @TBB_LIBS@ @LAPACK_LIBS@ @BLAS_LIBS@ -lm
+Cflags: -I${includedir}/spqr
